/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.16 from the
 * contents of LDAPapi.xs. Do not edit this file, edit LDAPapi.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "LDAPapi.xs"
/* This file was modified by Howard Chu, hyc@symas.com, 2000-2003.
 * Most changes are #if OPENLDAP, some are not marked.
 */
#ifdef __cplusplus
extern "C" {
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef __cplusplus
}
#endif

#include <lber.h>
#include <ldap.h>

#include <sasl/sasl.h>

/* Mozilla prototypes declare things as "const char *" while   */
/*      OpenLDAP uses "char *"                                 */

#ifdef MOZILLA_LDAP
 #define LDAP_CHAR const char
 #include <ldap_ssl.h>
#else

#ifndef OPENLDAP
 #include "ldap_compat.h"
#endif

 #define LDAP_CHAR char
#endif

#ifndef LDAP_RES_INTERMEDIATE
 #define LDAP_RES_INTERMEDIATE  0x79U /* 121 */
#endif

/* Function Prototypes for Internal Functions */

static char **av2modvals(AV *ldap_value_array_av, int ldap_isa_ber);
static LDAPMod *parse1mod(SV *ldap_value_ref,char *ldap_current_attribute,
    int ldap_add_func,int cont);
static LDAPMod **hash2mod(SV *ldap_change,int ldap_add_func, const char *func);

#ifdef OPENLDAP
   static int internal_rebind_proc(LDAP *ld,          LDAP_CONST char *url,
                                   ber_tag_t request, ber_int_t msgid,
                                   void *params);
#endif

/* The Name of the PERL function to return DN, PASSWD, AUTHTYPE on Rebind */
/* Set using 'set_rebind_proc()' */
SV *ldap_perl_rebindproc = NULL;


/* Use constant.h generated from constant.gen */
/* Courtesy of h.b.furuseth@usit.uio.no       */

#include "constant.h"


/* Strcasecmp - Some operating systems don't have this, including NT */

int StrCaseCmp(const char *s, const char *t)
{
   while (*s && *t && toupper(*s) == toupper(*t))
   {
      s++; t++;
   }
   return(toupper(*s) - toupper(*t));
}

/* av2modvals - Takes a single Array Reference (AV *) and returns */
/*    a null terminated list of char pointers.                    */

static
char **av2modvals(AV *ldap_value_array_av, int ldap_isa_ber)
{
   I32 ldap_arraylen;
   char **ldap_ch_modvalues = NULL;
   char *ldap_current_value_char = NULL;
   struct berval **ldap_bv_modvalues = NULL;
   struct berval *ldap_current_bval = NULL;
   SV **ldap_current_value_sv;
   int ldap_value_count = 0,ldap_pvlen,ldap_real_valuecount = 0;

   ldap_arraylen = av_len(ldap_value_array_av);
   if (ldap_arraylen < 0)
      return(NULL);

   if (ldap_isa_ber == 1)
   {
      New(1,ldap_bv_modvalues,2+ldap_arraylen,struct berval *);
   } else {
      New(1,ldap_ch_modvalues,2+ldap_arraylen,char *);
   }

   for (ldap_value_count = 0; ldap_value_count <=ldap_arraylen;
    ldap_value_count++)
   {
      ldap_current_value_sv = av_fetch(ldap_value_array_av,ldap_value_count,0);
      ldap_current_value_char = SvPV(*ldap_current_value_sv,PL_na);
      ldap_pvlen = SvCUR(*ldap_current_value_sv);
      if (strcmp(ldap_current_value_char,"") != 0)
      {
         if (ldap_isa_ber == 1)
         {
            New(1,ldap_current_bval,1,struct berval);
        ldap_current_bval->bv_len = ldap_pvlen;
        ldap_current_bval->bv_val = ldap_current_value_char;
        ldap_bv_modvalues[ldap_real_valuecount] = ldap_current_bval;
         } else {
            ldap_ch_modvalues[ldap_real_valuecount] = ldap_current_value_char;
         }
         ldap_real_valuecount++;
      }
   }
   if (ldap_isa_ber == 1)
   {
      ldap_bv_modvalues[ldap_real_valuecount] = NULL;
      return ((char **)ldap_bv_modvalues);
   } else {
      ldap_ch_modvalues[ldap_real_valuecount] = NULL;
      return (ldap_ch_modvalues);
   }
}


/* parse1mod - Take a single reference, figure out if it is a HASH, */
/*   ARRAY, or SCALAR, then extract the values and attributes and   */
/*   return a single LDAPMod pointer to this data.                  */

static
LDAPMod *parse1mod(SV *ldap_value_ref,char *ldap_current_attribute,
   int ldap_add_func,int cont)
{
   LDAPMod *ldap_current_mod;
   static HV *ldap_current_values_hv;
   HE *ldap_change_element;
   char *ldap_current_modop;
   SV *ldap_current_value_sv;
   I32 keylen;
   int ldap_isa_ber = 0;

   if (ldap_current_attribute == NULL)
      return(NULL);
   New(1,ldap_current_mod,1,LDAPMod);
   ldap_current_mod->mod_type = ldap_current_attribute;
   if (SvROK(ldap_value_ref))
   {
     if (SvTYPE(SvRV(ldap_value_ref)) == SVt_PVHV)
     {
      if (!cont)
      {
         ldap_current_values_hv = (HV *) SvRV(ldap_value_ref);
         hv_iterinit(ldap_current_values_hv);
      }
      if ((ldap_change_element = hv_iternext(ldap_current_values_hv)) == NULL)
     return(NULL);
      ldap_current_modop = hv_iterkey(ldap_change_element,&keylen);
      ldap_current_value_sv = hv_iterval(ldap_current_values_hv,
    ldap_change_element);
      if (ldap_add_func == 1)
      {
     ldap_current_mod->mod_op = 0;
      } else {
     if (strchr(ldap_current_modop,'a') != NULL)
     {
        ldap_current_mod->mod_op = LDAP_MOD_ADD;
     } else if (strchr(ldap_current_modop,'r') != NULL)
     {
        ldap_current_mod->mod_op = LDAP_MOD_REPLACE;
     } else if (strchr(ldap_current_modop,'d') != NULL) {
        ldap_current_mod->mod_op = LDAP_MOD_DELETE;
     } else {
        return(NULL);
     }
      }
      if (strchr(ldap_current_modop,'b') != NULL)
      {
     ldap_isa_ber = 1;
     ldap_current_mod->mod_op = ldap_current_mod->mod_op | LDAP_MOD_BVALUES;
      }
      if (SvTYPE(SvRV(ldap_current_value_sv)) == SVt_PVAV)
      {
     if (ldap_isa_ber == 1)
     {
        ldap_current_mod->mod_values =
          av2modvals((AV *)SvRV(ldap_current_value_sv),ldap_isa_ber);
     } else {
        ldap_current_mod->mod_values =
          av2modvals((AV *)SvRV(ldap_current_value_sv),ldap_isa_ber);
     }
      }
     } else if (SvTYPE(SvRV(ldap_value_ref)) == SVt_PVAV) {
      if (cont)
         return NULL;
      if (ldap_add_func == 1)
         ldap_current_mod->mod_op = 0;
      else
         ldap_current_mod->mod_op = LDAP_MOD_REPLACE;
      ldap_current_mod->mod_values = av2modvals((AV *)SvRV(ldap_value_ref),0);
      if (ldap_current_mod->mod_values == NULL)
      {
     ldap_current_mod->mod_op = LDAP_MOD_DELETE;
      }
     }
   } else {
      if (cont)
         return NULL;
      if (strcmp(SvPV(ldap_value_ref,PL_na),"") == 0)
      {
         if (ldap_add_func != 1)
         {
        ldap_current_mod->mod_op = LDAP_MOD_DELETE;
        ldap_current_mod->mod_values = NULL;
         } else {
            return(NULL);
         }
      } else {
         if (ldap_add_func == 1)
         {
            ldap_current_mod->mod_op = 0;
         } else {
        ldap_current_mod->mod_op = LDAP_MOD_REPLACE;
         }
         New(1,ldap_current_mod->mod_values,2,char *);
     ldap_current_mod->mod_values[0] = SvPV(ldap_value_ref,PL_na);
     ldap_current_mod->mod_values[1] = NULL;
      }
   }
   return(ldap_current_mod);
}


/* hash2mod - Cycle through all the keys in the hash and properly call */
/*    the appropriate functions to build a NULL terminated list of     */
/*    LDAPMod pointers.                                                */

static
LDAPMod ** hash2mod(SV *ldap_change_ref, int ldap_add_func, const char *func)
{
   LDAPMod **ldapmod = NULL;
   LDAPMod *ldap_current_mod;
   int ldap_attribute_count = 0;
   HE *ldap_change_element;
   char *ldap_current_attribute;
   SV *ldap_current_value_sv;
   I32 keylen;
   HV *ldap_change;

   if (!SvROK(ldap_change_ref) || SvTYPE(SvRV(ldap_change_ref)) != SVt_PVHV)
      croak("Net::LDAPapi::%s needs Hash reference as argument 3.",func);

   ldap_change = (HV *)SvRV(ldap_change_ref);

   hv_iterinit(ldap_change);
   while((ldap_change_element = hv_iternext(ldap_change)) != NULL)
   {
      ldap_current_attribute = hv_iterkey(ldap_change_element,&keylen);
      ldap_current_value_sv = hv_iterval(ldap_change,ldap_change_element);
      ldap_current_mod = parse1mod(ldap_current_value_sv,
    ldap_current_attribute,ldap_add_func,0);
      while (ldap_current_mod != NULL)
      {
         ldap_attribute_count++;
         (ldapmod
       ? Renew(ldapmod,1+ldap_attribute_count,LDAPMod *)
       : New(1,ldapmod,1+ldap_attribute_count,LDAPMod *));
         New(1,ldapmod[ldap_attribute_count -1],sizeof(LDAPMod),LDAPMod);
         Copy(ldap_current_mod,ldapmod[ldap_attribute_count-1],
       sizeof(LDAPMod),LDAPMod *);
         ldap_current_mod = parse1mod(ldap_current_value_sv,
           ldap_current_attribute,ldap_add_func,1);

      }
   }
   ldapmod[ldap_attribute_count] = NULL;
   return ldapmod;
}

/* internal_rebind_proc - Wrapper to call a PERL rebind process               */
/*   ldap_set_rebind_proc is slightly different between Mozilla and OpenLDAP  */

int
#ifdef OPENLDAP
internal_rebind_proc(LDAP *ld,          LDAP_CONST char *url,
                     ber_tag_t request, ber_int_t msgid,
                     void *params)
#endif
{
    return(LDAP_SUCCESS);
}

typedef struct bictx {
    char *authcid;
    char *passwd;
    char *realm;
    char *authzid;
} bictx;

static int
ldap_b2_interact(LDAP *ld, unsigned flags, void *def, void *inter)
{
    sasl_interact_t *in = inter;
    const char *p;
    bictx *ctx = def;
     for (;in->id != SASL_CB_LIST_END;in++)
    {
        p = NULL;
        switch(in->id)
        {
            case SASL_CB_GETREALM:
                p = ctx->realm;
                break;
            case SASL_CB_AUTHNAME:
                p = ctx->authcid;
                break;
            case SASL_CB_USER:
                p = ctx->authzid;
                break;
            case SASL_CB_PASS:
                p = ctx->passwd;
                break;
        }
        if (p)
        {
            in->len = strlen(p);
            in->result = p;
        }
    }
    return LDAP_SUCCESS;
}


#line 348 "LDAPapi.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 490 "LDAPapi.c"

XS_EUPXS(XS_Net__LDAPapi_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "name, arg");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	int	arg = (int)SvIV(ST(1))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = constant(name, arg);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_constant_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_constant_s)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = constant_s(name);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_initialize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_initialize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ldp, url");
    {
	LDAP *	ldp;
	LDAP_CHAR *	url = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 358 "LDAPapi.xs"
    {
       RETVAL = ldap_initialize(&ldp, url);
    }
#line 548 "LDAPapi.c"
	sv_setiv(ST(0), PTR2IV(ldp));
	SvSETMAGIC(ST(0));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ldp");
    {
	LDAP **	ldp;
	int	RETVAL;
	dXSTARG;
#line 369 "LDAPapi.xs"
    {
        RETVAL = ldap_create(ldp);
    }
#line 571 "LDAPapi.c"
	sv_setiv(ST(0), PTR2IV(ldp));
	SvSETMAGIC(ST(0));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_bind_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_bind_s)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ldp, dn, passwd, authmethod");
    {
	LDAP *	ldp = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAP_CHAR *	passwd = (LDAP_CHAR *)SvPV_nolen(ST(2))
;
	int	authmethod = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_bind_s(ldp, dn, passwd, authmethod);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_set_option); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_set_option)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, option, optdata");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	option = (int)SvIV(ST(1))
;
	int	optdata = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 389 "LDAPapi.xs"
    {
       RETVAL = ldap_set_option(ld,option,&optdata);
    }
#line 624 "LDAPapi.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_get_option); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_get_option)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, option, optdata");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	option = (int)SvIV(ST(1))
;
	int	optdata;
	int	RETVAL;
	dXSTARG;
#line 401 "LDAPapi.xs"
    {
       RETVAL = ldap_get_option(ld, option, &optdata);
    }
#line 649 "LDAPapi.c"
	sv_setiv(ST(2), (IV)optdata);
	SvSETMAGIC(ST(2));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_unbind_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_unbind_ext_s)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, sctrls, cctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(1)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(2)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_unbind_ext_s(ld, sctrls, cctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_search_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_search_s)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "ldp, base, scope, filter, attrs, attrsonly, res");
    {
	LDAP *	ldp = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	base = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	int	scope = (int)SvIV(ST(2))
;
	LDAP_CHAR *	filter = (LDAP_CHAR *)SvPV_nolen(ST(3))
;
	LDAP_CHAR **	attrs = INT2PTR(LDAP_CHAR **,SvIV(ST(4)))
;
	int	attrsonly = (int)SvIV(ST(5))
;
	LDAPMessage *	res;
	int	RETVAL;
	dXSTARG;
#line 424 "LDAPapi.xs"
    {
       RETVAL = ldap_search_s(ldp, base, scope, filter, attrs, attrsonly, &res);
    }
#line 707 "LDAPapi.c"
	sv_setiv(ST(6), PTR2IV(res));
	SvSETMAGIC(ST(6));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef MOZILLA_LDAP
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Net__LDAPapi_ldap_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ver");
    {
	LDAPVersion *	ver = INT2PTR(LDAPVersion *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_version(ver);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__LDAPapi_ldap_abandon_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_abandon_ext)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, msgid, sctrls, cctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	msgid = (int)SvIV(ST(1))
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(2)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_abandon_ext(ld, msgid, sctrls, cctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_add_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_add_ext)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, dn, ldap_change_ref, sctrls, cctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	SV *	ldap_change_ref = ST(2)
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;
#line 455 "LDAPapi.xs"
    {
        LDAPMod ** attrs = hash2mod(ldap_change_ref, 1, "ldap_add_ext");
        RETVAL = ldap_add_ext(ld, dn, attrs, sctrls, cctrls, &msgidp);
        Safefree(attrs);
    }
#line 790 "LDAPapi.c"
	sv_setiv(ST(5), (IV)msgidp);
	SvSETMAGIC(ST(5));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_add_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_add_ext_s)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, dn, ldap_change_ref, sctrls, cctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAPMod **	ldap_change_ref = hash2mod(ST(2), 1, "ldap_add_ext_s");
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_add_ext_s(ld, dn, ldap_change_ref, sctrls, cctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
#line 472 "LDAPapi.xs"
       Safefree(ldap_change_ref);
#line 822 "LDAPapi.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_sasl_bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_sasl_bind)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "ld, dn, passwd, sctrls, serverctrls, clientctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAP_CHAR *	passwd = (LDAP_CHAR *)SvPV_nolen(ST(2))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;
#line 483 "LDAPapi.xs"
    {
        struct berval cred;

        if( passwd == NULL )
            cred.bv_val = "";
        else
            cred.bv_val = passwd;

        cred.bv_len = strlen(cred.bv_val);

        RETVAL = ldap_sasl_bind(ld, dn, LDAP_SASL_SIMPLE, &cred,
                                serverctrls, clientctrls, &msgidp);
    }
#line 862 "LDAPapi.c"
	sv_setiv(ST(6), (IV)msgidp);
	SvSETMAGIC(ST(6));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_modify_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_modify_ext)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, dn, ldap_change_ref, sctrls, cctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	SV *	ldap_change_ref = ST(2)
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;
#line 509 "LDAPapi.xs"
    {
        LDAPMod ** mods  = hash2mod(ldap_change_ref, 0, "ldap_modify_ext");
        RETVAL = ldap_modify_ext(ld, dn, mods, sctrls, cctrls, &msgidp);
        Safefree(mods);
    }
#line 897 "LDAPapi.c"
	sv_setiv(ST(5), (IV)msgidp);
	SvSETMAGIC(ST(5));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_modify_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_modify_ext_s)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, dn, ldap_change_ref, sctrl, cctrl");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAPMod **	ldap_change_ref = hash2mod(ST(2), 0, "ldap_modify_ext_s");
	LDAPControl **	sctrl = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	cctrl = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_modify_ext_s(ld, dn, ldap_change_ref, sctrl, cctrl);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_rename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_rename)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "ld, dn, newrdn, newSuperior, deleteoldrdn, sctrls, cctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAP_CHAR *	newrdn = (LDAP_CHAR *)SvPV_nolen(ST(2))
;
	LDAP_CHAR *	newSuperior = (LDAP_CHAR *)SvPV_nolen(ST(3))
;
	int	deleteoldrdn = (int)SvIV(ST(4))
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(6)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;
#line 537 "LDAPapi.xs"
    {
        RETVAL = ldap_rename(ld, dn, newrdn, newSuperior,
                    deleteoldrdn, sctrls, cctrls, &msgidp);
    }
#line 961 "LDAPapi.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_rename_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_rename_s)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "ld, dn, newrdn, newSuperior, deleteoldrdn, sctrls, cctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAP_CHAR *	newrdn = (LDAP_CHAR *)SvPV_nolen(ST(2))
;
	LDAP_CHAR *	newSuperior = (LDAP_CHAR *)SvPV_nolen(ST(3))
;
	int	deleteoldrdn = (int)SvIV(ST(4))
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(6)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_rename_s(ld, dn, newrdn, newSuperior, deleteoldrdn, sctrls, cctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_compare_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_compare_ext)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "ld, dn, attr, value, sctrls, cctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAP_CHAR *	attr = (LDAP_CHAR *)SvPV_nolen(ST(2))
;
	LDAP_CHAR *	value = (LDAP_CHAR *)SvPV_nolen(ST(3))
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;
#line 564 "LDAPapi.xs"
    {
        struct berval bvalue;
        bvalue.bv_len = strlen(value);
        bvalue.bv_val = value;
        RETVAL = ldap_compare_ext(ld, dn, attr, &bvalue, sctrls, cctrls, &msgidp);
    }
#line 1028 "LDAPapi.c"
	sv_setiv(ST(6), (IV)msgidp);
	SvSETMAGIC(ST(6));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_compare_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_compare_ext_s)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, dn, attr, value, sctrls, cctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAP_CHAR *	attr = (LDAP_CHAR *)SvPV_nolen(ST(2))
;
	LDAP_CHAR *	value = (LDAP_CHAR *)SvPV_nolen(ST(3))
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	int	RETVAL;
	dXSTARG;
#line 583 "LDAPapi.xs"
    {
        struct berval bvalue;
        bvalue.bv_len = strlen(value);
        bvalue.bv_val = value;
        RETVAL = ldap_compare_ext_s(ld, dn, attr, &bvalue, sctrls, cctrls);
    }
#line 1065 "LDAPapi.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_delete_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_delete_ext)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, dn, sctrls, cctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(2)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;
#line 600 "LDAPapi.xs"
    {
        RETVAL = ldap_delete_ext(ld, dn, sctrls, cctrls, &msgidp);
    }
#line 1094 "LDAPapi.c"
	sv_setiv(ST(4), (IV)msgidp);
	SvSETMAGIC(ST(4));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_delete_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_delete_ext_s)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, dn, sctrls, cctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(2)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_delete_ext_s(ld, dn, sctrls, cctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_search_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_search_ext)
{
    dVAR; dXSARGS;
    if (items != 11)
       croak_xs_usage(cv,  "ld, base, scope, filter, attrs, attrsonly, sctrls, cctrls, timeout, sizelimit, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	base = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	int	scope = (int)SvIV(ST(2))
;
	LDAP_CHAR *	filter = (LDAP_CHAR *)SvPV_nolen(ST(3))
;
	SV *	attrs = ST(4)
;
	int	attrsonly = (int)SvIV(ST(5))
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(6)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(7)))
;
	struct timeval *	timeout = INT2PTR(struct timeval *,SvIV(ST(8)))
;
	int	sizelimit = (int)SvIV(ST(9))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;
#line 629 "LDAPapi.xs"
    {
       char **attrs_char;
       SV **current;
       int arraylen,count;

       if (SvTYPE(SvRV(attrs)) != SVt_PVAV)
       {
          croak("Net::LDAPapi::ldap_search_ext needs ARRAY reference as argument 5.");
          XSRETURN(1);
       }

       if ((arraylen = av_len((AV *)SvRV(attrs))) < 0)
       {
          New(1,attrs_char,2,char *);
          attrs_char[0] = NULL;
       } else {
          New(1,attrs_char,arraylen+2,char *);
          for (count=0;count <= arraylen; count++)
          {
            current = av_fetch((AV *)SvRV(attrs),count,0);
            attrs_char[count] = SvPV(*current,PL_na);
          }
          attrs_char[arraylen+1] = NULL;
       }
       RETVAL = ldap_search_ext(ld,        base,   scope,  filter,  attrs_char,
                                attrsonly, sctrls, cctrls, timeout, sizelimit,
                                &msgidp);
       Safefree(attrs_char);
    }
#line 1188 "LDAPapi.c"
	sv_setiv(ST(10), (IV)msgidp);
	SvSETMAGIC(ST(10));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_search_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_search_ext_s)
{
    dVAR; dXSARGS;
    if (items != 11)
       croak_xs_usage(cv,  "ld, base, scope, filter, attrs, attrsonly, sctrls, cctrls, timeout, sizelimit, res");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	base = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	int	scope = (int)SvIV(ST(2))
;
	LDAP_CHAR *	filter = (LDAP_CHAR *)SvPV_nolen(ST(3))
;
	SV *	attrs = ST(4)
;
	int	attrsonly = (int)SvIV(ST(5))
;
	LDAPControl **	sctrls = INT2PTR(LDAPControl **,SvIV(ST(6)))
;
	LDAPControl **	cctrls = INT2PTR(LDAPControl **,SvIV(ST(7)))
;
	struct timeval *	timeout = INT2PTR(struct timeval *,SvIV(ST(8)))
;
	int	sizelimit = (int)SvIV(ST(9))
;
	LDAPMessage *	res;
	int	RETVAL;
	dXSTARG;
#line 676 "LDAPapi.xs"
    {
       char **attrs_char;
       SV **current;
       int arraylen,count;

       if (SvTYPE(SvRV(attrs)) == SVt_PVAV)
       {
          if ((arraylen = av_len((AV *)SvRV(attrs))) < 0)
          {
             New(1, attrs_char, 2, char *);
             attrs_char[0] = NULL;
          } else {
             New(1, attrs_char, arraylen+2, char *);
             for (count=0;count <= arraylen; count++)
             {
                current = av_fetch((AV *)SvRV(attrs),count,0);
                attrs_char[count] = SvPV(*current,PL_na);
             }
             attrs_char[arraylen+1] = NULL;
          }
       } else {
          croak("Net::LDAPapi::ldap_search_ext_s needs ARRAY reference as argument 5.");
          XSRETURN(1);
       }
       RETVAL = ldap_search_ext_s(ld,base,scope,filter,attrs_char,attrsonly,sctrls,cctrls,timeout,sizelimit,&res);
       Safefree(attrs_char);
    }
#line 1255 "LDAPapi.c"
	sv_setiv(ST(10), PTR2IV(res));
	SvSETMAGIC(ST(10));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_result); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_result)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, msgid, all, timeout, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	msgid = (int)SvIV(ST(1))
;
	int	all = (int)SvIV(ST(2))
;
	LDAP_CHAR *	timeout = (LDAP_CHAR *)SvPV_nolen(ST(3))
;
	LDAPMessage *	result;
	int	RETVAL;
	dXSTARG;
#line 716 "LDAPapi.xs"
    {
        struct timeval *tv_timeout = NULL, timeoutbuf;
        if (atof(timeout) > 0 && timeout && *timeout)
        {
           tv_timeout = &timeoutbuf;
           tv_timeout->tv_sec = atof(timeout);
           tv_timeout->tv_usec = 0;
        }
        RETVAL = ldap_result(ld, msgid, all, NULL, &result);
    }
#line 1293 "LDAPapi.c"
	sv_setiv(ST(4), PTR2IV(result));
	SvSETMAGIC(ST(4));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_msgfree); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_msgfree)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lm");
    {
	LDAPMessage *	lm = INT2PTR(LDAPMessage *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_msgfree(lm);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ber_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ber_free)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ber, freebuf");
    {
	BerElement *	ber = INT2PTR(BerElement *,SvIV(ST(0)))
;
	int	freebuf = (int)SvIV(ST(1))
;

	ber_free(ber, freebuf);
    }
    XSRETURN_EMPTY;
}

#if defined(MOZILLA_LDAP) || defined(OPENLDAP)
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Net__LDAPapi_ldap_msgid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_msgid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lm");
    {
	LDAPMessage *	lm = INT2PTR(LDAPMessage *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_msgid(lm);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_msgtype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_msgtype)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lm");
    {
	LDAPMessage *	lm = INT2PTR(LDAPMessage *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_msgtype(lm);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAC 1


XS_EUPXS(XS_Net__LDAPapi_ldap_msgid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_msgid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lm");
    {
	LDAPMessage *	lm = INT2PTR(LDAPMessage *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 756 "LDAPapi.xs"
    {
       RETVAL = lm->lm_msgid;
    }
#line 1398 "LDAPapi.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_msgtype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_msgtype)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lm");
    {
	LDAPMessage *	lm = INT2PTR(LDAPMessage *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 766 "LDAPapi.xs"
    {
       RETVAL = lm->lm_msgtype;
    }
#line 1420 "LDAPapi.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#if defined(MOZILLA_LDAP)
#define XSubPPtmpAAAD 1


XS_EUPXS(XS_Net__LDAPapi_ldap_get_lderrno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_get_lderrno)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, m, s");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	char *	m;
	char *	s;
	int	RETVAL;
	dXSTARG;
#line 782 "LDAPapi.xs"
    {
       RETVAL = ldap_get_lderrno(ld,&m,&s);
    }
#line 1448 "LDAPapi.c"
	sv_setpv((SV*)ST(1), m);
	SvSETMAGIC(ST(1));
	sv_setpv((SV*)ST(2), s);
	SvSETMAGIC(ST(2));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_set_lderrno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_set_lderrno)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, e, m, s");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	e = (int)SvIV(ST(1))
;
	char *	m = (char *)SvPV_nolen(ST(2))
;
	char *	s = (char *)SvPV_nolen(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_set_lderrno(ld, e, m, s);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAE 1


XS_EUPXS(XS_Net__LDAPapi_ldap_get_lderrno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_get_lderrno)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, m, s");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	char *	m;
	char *	s;
	int	RETVAL;
	dXSTARG;
#line 805 "LDAPapi.xs"
    {
#ifdef OPENLDAP
       ldap_get_option(ld, LDAP_OPT_ERROR_NUMBER, &RETVAL);
       ldap_get_option(ld, LDAP_OPT_ERROR_STRING, &s);
       ldap_get_option(ld, LDAP_OPT_MATCHED_DN, &m);
#else
       RETVAL = ld->ld_errno;
       m = ld->ld_matched;
       s = ld->ld_error;
#endif
    }
#line 1512 "LDAPapi.c"
	sv_setpv((SV*)ST(1), m);
	SvSETMAGIC(ST(1));
	sv_setpv((SV*)ST(2), s);
	SvSETMAGIC(ST(2));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_set_lderrno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_set_lderrno)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, e, m, s");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	e = (int)SvIV(ST(1))
;
	char *	m = (char *)SvPV_nolen(ST(2))
;
	char *	s = (char *)SvPV_nolen(ST(3))
;
	int	RETVAL;
	dXSTARG;
#line 828 "LDAPapi.xs"
    {
       RETVAL = 0;
#ifdef OPENLDAP
       ldap_set_option(ld, LDAP_OPT_ERROR_NUMBER, &e);
       ldap_set_option(ld, LDAP_OPT_ERROR_STRING, s);
       ldap_set_option(ld, LDAP_OPT_MATCHED_DN, m);
#else
       ld->ld_errno = e;
       ld->ld_matched = m;
       ld->ld_error = s;
#endif
    }
#line 1553 "LDAPapi.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__LDAPapi_ldap_get_entry_controls); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_get_entry_controls)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, entry, serverctrls_ref");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	SV *	serverctrls_ref = ST(2)
;
	int	RETVAL;
	dXSTARG;
#line 851 "LDAPapi.xs"
    {
        int i;

        if (SvTYPE(SvRV(serverctrls_ref)) != SVt_PVAV)
        {
           croak("Net::LDAPapi::ldap_get_entry_controls needs ARRAY reference as argument 3.");
            XSRETURN(-1);
        }

        AV *serverctrls_av = (AV *)SvRV(serverctrls_ref);

        LDAPControl **serverctrls = malloc(sizeof(LDAPControl **));
        if( serverctrls == NULL ) {
            croak("In ldap_parse_result(...) failed to allocate memory for serverctrls.");
            XSRETURN(-1);
        }

        RETVAL = ldap_get_entry_controls( ld, entry, &serverctrls);

        // transfer returned controls to the perl code
        if( serverctrls != NULL ) {
            for( i = 0; serverctrls[i] != NULL; i++ )
                av_push(serverctrls_av, newSViv((IV)serverctrls[i]));
        }

        free(serverctrls);

        SvRV( serverctrls_ref ) = (SV *)serverctrls_av;
    }
#line 1606 "LDAPapi.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_parse_result); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_parse_result)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "ld, msg, errorcodep, matcheddnp, errmsgp, referrals_ref, serverctrls_ref, freeit");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	msg = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	int	errorcodep;
	char *	matcheddnp;
	char *	errmsgp;
	SV *	referrals_ref = ST(5)
;
	SV *	serverctrls_ref = ST(6)
;
	int	freeit = (int)SvIV(ST(7))
;
	int	RETVAL;
	dXSTARG;
#line 894 "LDAPapi.xs"
    {
        int i;

        if (SvTYPE(SvRV(referrals_ref)) != SVt_PVAV)
        {
            croak("Net::LDAPapi::ldap_parse_result needs ARRAY reference as argument 6.");
            XSRETURN(-1);
        }

        if (SvTYPE(SvRV(serverctrls_ref)) != SVt_PVAV)
        {
            croak("Net::LDAPapi::ldap_parse_result needs ARRAY reference as argument 7.");
            XSRETURN(-1);
        }

        AV *serverctrls_av = (AV *)SvRV(serverctrls_ref);
        AV *referrals_av  = (AV *)SvRV(referrals_ref);

        LDAPControl **serverctrls = malloc(sizeof(LDAPControl **));
        if( serverctrls == NULL ) {
            croak("In ldap_parse_result(...) failed to allocate memory for serverctrls.");
            XSRETURN(-1);
        }

        char **referrals  = malloc(sizeof(char **));
        if( referrals == NULL ) {
            croak("In ldap_parse_result(...) failed to allocate memory for referrals.");
            free(referrals);
            XSRETURN(-1);
        }

        RETVAL =
            ldap_parse_result(ld,       msg,        &errorcodep,  &matcheddnp,
                              &errmsgp, &referrals, &serverctrls, freeit);

        // transfer returned referrals to the perl code
        if( referrals != NULL ) {
            for( i = 0; referrals[i] != NULL; i++ )
                av_push(referrals_av, newSViv((IV)referrals[i]));
        }

        // transfer returned controls to the perl code
        if( serverctrls != NULL ) {
            for( i = 0; serverctrls[i] != NULL; i++ )
                av_push(serverctrls_av, newSViv((IV)serverctrls[i]));
        }

        free(serverctrls);
        free(referrals);

        SvRV( referrals_ref ) = (SV *)referrals_av;
        SvRV( serverctrls_ref ) = (SV *)serverctrls_av;
    }
#line 1689 "LDAPapi.c"
	sv_setiv(ST(2), (IV)errorcodep);
	SvSETMAGIC(ST(2));
	sv_setpv((SV*)ST(3), matcheddnp);
	SvSETMAGIC(ST(3));
	sv_setpv((SV*)ST(4), errmsgp);
	SvSETMAGIC(ST(4));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_parse_intermediate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_parse_intermediate)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, msg, retoidp, retdatap, serverctrls_ref, freeit");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	msg = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	char *	retoidp;
	char *	retdatap;
	SV *	serverctrls_ref = ST(4)
;
	int	freeit = (int)SvIV(ST(5))
;
	int	RETVAL;
	dXSTARG;
#line 962 "LDAPapi.xs"
    {
        int i;
        struct berval *retdata;

        if (SvTYPE(SvRV(serverctrls_ref)) != SVt_PVAV)
        {
            croak("Net::LDAPapi::ldap_parse_intermediate needs ARRAY reference as argument 5.");
            XSRETURN(-1);
        }

        AV *serverctrls_av = (AV *)SvRV(serverctrls_ref);

        LDAPControl **serverctrls = malloc(sizeof(LDAPControl **));
        if( serverctrls == NULL ) {
            croak("In ldap_parse_intermediate(...) failed to allocate memory for serverctrls.");
            XSRETURN(-1);
        }

        retdata = malloc(sizeof(struct berval *));

        RETVAL =
            ldap_parse_intermediate(ld,       msg,          &retoidp,
                                    &retdata, &serverctrls, freeit);

        if( retdata != NULL )
            retdatap = ldap_strdup(retdata->bv_val);

        // transfer returned controls to the perl code
        if( serverctrls != NULL ) {
            for( i = 0; serverctrls[i] != NULL; i++ )
                av_push(serverctrls_av, newSViv((IV)serverctrls[i]));
        }

        free(serverctrls);
        free(retdata);

        SvRV( serverctrls_ref ) = (SV *)serverctrls_av;
    }
#line 1760 "LDAPapi.c"
	sv_setpv((SV*)ST(2), retoidp);
	SvSETMAGIC(ST(2));
	sv_setpv((SV*)ST(3), retdatap);
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_control_oid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_control_oid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "control");
    {
	LDAPControl *	control = INT2PTR(LDAPControl *,SvIV(ST(0)))
;
	char *	RETVAL;
	dXSTARG;
#line 1010 "LDAPapi.xs"
    {
        RETVAL = control->ldctl_oid;
    }
#line 1786 "LDAPapi.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_control_berval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_control_berval)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "control");
    {
	LDAPControl *	control = INT2PTR(LDAPControl *,SvIV(ST(0)))
;
	char *	RETVAL;
	dXSTARG;
#line 1021 "LDAPapi.xs"
    {
        RETVAL = control->ldctl_value.bv_val;
    }
#line 1808 "LDAPapi.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_control_critical); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_control_critical)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "control");
    {
	LDAPControl *	control = INT2PTR(LDAPControl *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
#line 1032 "LDAPapi.xs"
    {
        RETVAL = control->ldctl_iscritical;
    }
#line 1830 "LDAPapi.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_err2string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_err2string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "err");
    {
	int	err = (int)SvIV(ST(0))
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = ldap_err2string(err);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_count_references); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_count_references)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	result = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_count_references(ld, result);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_count_entries); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_count_entries)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	result = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_count_entries(ld, result);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_first_entry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_first_entry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	result = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPMessage *	RETVAL;
	dXSTARG;

	RETVAL = ldap_first_entry(ld, result);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_next_entry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_next_entry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, preventry");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	preventry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPMessage *	RETVAL;
	dXSTARG;

	RETVAL = ldap_next_entry(ld, preventry);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_first_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_first_message)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, chain");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	chain = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPMessage *	RETVAL;
	dXSTARG;

	RETVAL = ldap_first_message(ld, chain);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_next_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_next_message)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, chain");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	chain = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPMessage *	RETVAL;
	dXSTARG;

	RETVAL = ldap_next_message(ld, chain);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_get_dn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_get_dn)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, entry");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
#line 1082 "LDAPapi.xs"
       char * dn;
#line 1995 "LDAPapi.c"
	SV *	RETVAL;
#line 1084 "LDAPapi.xs"
    {
       dn = ldap_get_dn(ld, entry);
       if (dn)
       {
          RETVAL = newSVpv(dn,0);
          ldap_memfree(dn);
       } else {
          RETVAL = &PL_sv_undef;
       }
    }
#line 2008 "LDAPapi.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_perror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_perror)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, s");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	s = (LDAP_CHAR *)SvPV_nolen(ST(1))
;

	ldap_perror(ld, s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LDAPapi_ldap_dn2ufn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_dn2ufn)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dn");
    {
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(0))
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = ldap_dn2ufn(dn);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

#if defined(OPENLDAP)
#define XSubPPtmpAAAF 1


XS_EUPXS(XS_Net__LDAPapi_ldap_str2dn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_str2dn)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "str, dn, flags");
    {
	LDAP_CHAR *	str = (LDAP_CHAR *)SvPV_nolen(ST(0))
;
	LDAPDN *	dn = INT2PTR(LDAPDN *,SvIV(ST(1)))
;
	unsigned	flags = (unsigned)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_str2dn(str, dn, flags);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_str2rdn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_str2rdn)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "str, rdn, n_in, flags");
    {
	LDAP_CHAR *	str = (LDAP_CHAR *)SvPV_nolen(ST(0))
;
	LDAPRDN *	rdn = INT2PTR(LDAPRDN *,SvIV(ST(1)))
;
	char **	n_in = INT2PTR(char **,SvIV(ST(2)))
;
	unsigned	flags = (unsigned)SvUV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_str2rdn(str, rdn, n_in, flags);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__LDAPapi_ldap_explode_dn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_explode_dn)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dn, notypes");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	dn = (char *)SvPV_nolen(ST(0))
;
	int	notypes = (int)SvIV(ST(1))
;
#line 1126 "LDAPapi.xs"
    {
       char ** LDAPGETVAL;
       int i;

       if ((LDAPGETVAL = ldap_explode_dn(dn,notypes)) != NULL)
       {
           for (i = 0; LDAPGETVAL[i] != NULL; i++)
           {
          EXTEND(sp,1);
          PUSHs(sv_2mortal(newSVpv(LDAPGETVAL[i],strlen(LDAPGETVAL[i]))));
           }
          ldap_value_free(LDAPGETVAL);
       }
    }
#line 2133 "LDAPapi.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__LDAPapi_ldap_explode_rdn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_explode_rdn)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dn, notypes");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	dn = (char *)SvPV_nolen(ST(0))
;
	int	notypes = (int)SvIV(ST(1))
;
#line 1146 "LDAPapi.xs"
    {
       char ** LDAPGETVAL;
       int i;

       if ((LDAPGETVAL = ldap_explode_rdn(dn,notypes)) != NULL)
       {
           for (i = 0; LDAPGETVAL[i] != NULL; i++)
           {
          EXTEND(sp,1);
          PUSHs(sv_2mortal(newSVpv(LDAPGETVAL[i],strlen(LDAPGETVAL[i]))));
           }
          ldap_value_free(LDAPGETVAL);
       }
    }
#line 2168 "LDAPapi.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__LDAPapi_ldap_first_attribute); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_first_attribute)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, entry, ber");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	BerElement *	ber;
#line 1167 "LDAPapi.xs"
       char * attr;
#line 2189 "LDAPapi.c"
	SV *	RETVAL;
#line 1169 "LDAPapi.xs"
    {
       attr = ldap_first_attribute(ld, entry, &ber);
       if (attr)
       {
          RETVAL = newSVpv(attr,0);
          ldap_memfree(attr);
       } else {
          RETVAL = &PL_sv_undef;
       }
    }
#line 2202 "LDAPapi.c"
	sv_setiv(ST(2), PTR2IV(ber));
	SvSETMAGIC(ST(2));
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_next_attribute); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_next_attribute)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, entry, ber");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	BerElement *	ber = INT2PTR(BerElement *,SvIV(ST(2)))
;
#line 1189 "LDAPapi.xs"
       char * attr;
#line 2227 "LDAPapi.c"
	SV *	RETVAL;
#line 1191 "LDAPapi.xs"
    {
       attr = ldap_next_attribute(ld, entry, ber);
       if (attr)
       {
          RETVAL = newSVpv(attr,0);
          ldap_memfree(attr);
       } else {
          RETVAL = &PL_sv_undef;
       }
    }
#line 2240 "LDAPapi.c"
	sv_setiv(ST(2), PTR2IV(ber));
	SvSETMAGIC(ST(2));
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_get_values_len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_get_values_len)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, entry, target");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	char *	target = (char *)SvPV_nolen(ST(2))
;
#line 1212 "LDAPapi.xs"
    {
       struct berval ** LDAPGETVAL;
       int i;

       if ((LDAPGETVAL = ldap_get_values_len(ld,entry,target)) != NULL)
       {
           for (i = 0; LDAPGETVAL[i] != NULL; i++)
           {
          EXTEND(sp,1);
          PUSHs(sv_2mortal(newSVpv(LDAPGETVAL[i]->bv_val,LDAPGETVAL[i]->bv_len)));
           }
       }
    }
#line 2279 "LDAPapi.c"
	PUTBACK;
	return;
    }
}

#ifdef MOZILLA_LDAP
#define XSubPPtmpAAAG 1


XS_EUPXS(XS_Net__LDAPapi_ldapssl_client_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldapssl_client_init)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "certdbpath, certdbhandle");
    {
	char *	certdbpath = (char *)SvPV_nolen(ST(0))
;
	void *	certdbhandle = INT2PTR(void *,SvIV(ST(1)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldapssl_client_init(certdbpath, certdbhandle);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldapssl_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldapssl_init)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "defhost, defport, defsecure");
    {
	char *	defhost = (char *)SvPV_nolen(ST(0))
;
	int	defport = (int)SvIV(ST(1))
;
	int	defsecure = (int)SvIV(ST(2))
;
	LDAP *	RETVAL;
	dXSTARG;

	RETVAL = ldapssl_init(defhost, defport, defsecure);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldapssl_install_routines); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldapssl_install_routines)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ld");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldapssl_install_routines(ld);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__LDAPapi_ldap_set_rebind_proc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_set_rebind_proc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, rebind_function, args");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	SV *	rebind_function = ST(1)
;
	void *	args = INT2PTR(void *,SvIV(ST(2)))
;
#line 1251 "LDAPapi.xs"
    {
       if (SvTYPE(SvRV(rebind_function)) != SVt_PVCV)
       {
          // rebind_function is not actually a function
          // and we set rebind function to NULL
#if defined(MOZILLA_LDAP) || defined(OPENLDAP)
          ldap_set_rebind_proc(ld,NULL,NULL);
#else
          ldap_set_rebind_proc(ld,NULL);
#endif
       } else {
          if (ldap_perl_rebindproc == (SV*)NULL)
             ldap_perl_rebindproc = newSVsv(rebind_function);
          else
             SvSetSV(ldap_perl_rebindproc, rebind_function);
#if defined(OPENLDAP)
          ldap_set_rebind_proc(ld, internal_rebind_proc, args);
#endif
       }
    }
#line 2387 "LDAPapi.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LDAPapi_ldap_get_all_entries); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_get_all_entries)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	result = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	HV *	RETVAL;
#line 1277 "LDAPapi.xs"
    {
       LDAPMessage *entry = NULL;
       char *dn = NULL, *attr = NULL;
       struct berval **vals = NULL;
       BerElement *ber = NULL;
       int count = 0;
       HV*   FullHash = newHV();

       for ( entry = ldap_first_entry(ld, result); entry != NULL;
        entry = ldap_next_entry(ld, entry) )
       {
          HV* ResultHash = newHV();
          SV* HashRef = newRV((SV*) ResultHash);

          if ((dn = ldap_get_dn(ld, entry)) == NULL)
              continue;

          for ( attr = ldap_first_attribute(ld, entry, &ber);
          attr != NULL;
          attr = ldap_next_attribute(ld, entry, ber) )
          {
              AV* AttributeValsArray = newAV();
              SV* ArrayRef = newRV((SV*) AttributeValsArray);
              if ((vals = ldap_get_values_len(ld, entry, attr)) != NULL)
              {
                  for (count=0; vals[count] != NULL; count++)
                  {
                      SV* SVval = newSVpvn(vals[count]->bv_val, vals[count]->bv_len);
                      av_push(AttributeValsArray, SVval);
                  }
              }
              hv_store(ResultHash, attr, strlen(attr), ArrayRef, 0);
              if (vals != NULL)
                  ldap_value_free_len(vals);
         }
         if (attr != NULL)
             ldap_memfree(attr);
         hv_store(FullHash, dn, strlen(dn), HashRef, 0);
         if (dn != NULL)
             ldap_memfree(dn);
#if defined(MOZILLA_LDAP) || defined(OPENLDAP)
         if (ber != NULL)
            ber_free(ber,0);
#endif
       }
       RETVAL = FullHash;
    }
#line 2453 "LDAPapi.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_is_ldap_url); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_is_ldap_url)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "url");
    {
	LDAP_CHAR *	url = (LDAP_CHAR *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_is_ldap_url(url);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_url_parse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_url_parse)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "url");
    {
	LDAP_CHAR *	url = (LDAP_CHAR *)SvPV_nolen(ST(0))
;
	SV *	RETVAL;
#line 1335 "LDAPapi.xs"
    {
       LDAPURLDesc *realcomp;
       int count,ret;

       HV*   FullHash = newHV();
       RETVAL = newRV((SV*)FullHash);

       ret = ldap_url_parse(url,&realcomp);
       if (ret == 0)
       {
          static char *host_key = "host";
          static char *port_key = "port";
          static char *dn_key = "dn";
          static char *attr_key = "attr";
          static char *scope_key = "scope";
          static char *filter_key = "filter";
#ifdef MOZILLA_LDAP
          static char *options_key = "options";
          SV* options = newSViv(realcomp->lud_options);
#endif
#ifdef OPENLDAP
          static char *scheme_key = "scheme";
          static char *exts_key = "exts";
          AV* extsarray = newAV();
          SV* extsibref = newRV((SV*) extsarray);
          SV* scheme = newSVpv(realcomp->lud_scheme,0);
#endif
          SV* host = newSVpv(realcomp->lud_host,0);
          SV* port = newSViv(realcomp->lud_port);
          SV* dn; /* = newSVpv(realcomp->lud_dn,0); */
          SV* scope = newSViv(realcomp->lud_scope);
          SV* filter = newSVpv(realcomp->lud_filter,0);
          AV* attrarray = newAV();
          SV* attribref = newRV((SV*) attrarray);

          if (realcomp->lud_dn)
                 dn = newSVpv(realcomp->lud_dn,0);
          else
             dn = newSVpv("",0);

          if (realcomp->lud_attrs != NULL)
          {
             for (count=0; realcomp->lud_attrs[count] != NULL; count++)
             {
                SV* SVval = newSVpv(realcomp->lud_attrs[count],0);
                av_push(attrarray, SVval);
             }
          }
#ifdef OPENLDAP
          if (realcomp->lud_exts != NULL)
          {
             for (count=0; realcomp->lud_exts[count] != NULL; count++)
             {
                SV* SVval = newSVpv(realcomp->lud_exts[count],0);
                av_push(extsarray, SVval);
             }
          }
          hv_store(FullHash,exts_key,strlen(exts_key),extsibref,0);
          hv_store(FullHash,scheme_key,strlen(scheme_key),scheme,0);
#endif
          hv_store(FullHash,host_key,strlen(host_key),host,0);
          hv_store(FullHash,port_key,strlen(port_key),port,0);
          hv_store(FullHash,dn_key,strlen(dn_key),dn,0);
          hv_store(FullHash,attr_key,strlen(attr_key),attribref,0);
          hv_store(FullHash,scope_key,strlen(scope_key),scope,0);
          hv_store(FullHash,filter_key,strlen(filter_key),filter,0);
#ifdef MOZILLA_LDAP
          hv_store(FullHash,options_key,strlen(options_key),options,0);
#endif
          ldap_free_urldesc(realcomp);
       } else {
          RETVAL = &PL_sv_undef;
       }
    }
#line 2565 "LDAPapi.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifndef OPENLDAP
#define XSubPPtmpAAAH 1


XS_EUPXS(XS_Net__LDAPapi_ldap_url_search); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_url_search)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, url, attrsonly");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	char *	url = (char *)SvPV_nolen(ST(1))
;
	int	attrsonly = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_url_search(ld, url, attrsonly);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_url_search_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_url_search_s)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, url, attrsonly, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	char *	url = (char *)SvPV_nolen(ST(1))
;
	int	attrsonly = (int)SvIV(ST(2))
;
	LDAPMessage *	result;
	int	RETVAL;
	dXSTARG;
#line 1427 "LDAPapi.xs"
    {
       RETVAL = ldap_url_search_s(ld,url,attrsonly,&result);
    }
#line 2619 "LDAPapi.c"
	sv_setiv(ST(3), PTR2IV(result));
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_url_search_st); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_url_search_st)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, url, attrsonly, timeout, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	char *	url = (char *)SvPV_nolen(ST(1))
;
	int	attrsonly = (int)SvIV(ST(2))
;
	LDAP_CHAR *	timeout = (LDAP_CHAR *)SvPV_nolen(ST(3))
;
	LDAPMessage *	result;
	int	RETVAL;
	dXSTARG;
#line 1442 "LDAPapi.xs"
    {
       struct timeval *tv_timeout = NULL, timeoutbuf;
       if (timeout && *timeout)
       {
          tv_timeout = &timeoutbuf;
          tv_timeout->tv_sec = atof(timeout);
          tv_timeout->tv_usec = 0;
       }
       RETVAL = ldap_url_search_st(ld,url,attrsonly,tv_timeout,&result);
    }
#line 2657 "LDAPapi.c"
	sv_setiv(ST(4), PTR2IV(result));
	SvSETMAGIC(ST(4));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__LDAPapi_ldap_sort_entries); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_sort_entries)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, chain, attr");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	chain = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	char *	attr = (char *)SvPV_nolen(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 1464 "LDAPapi.xs"
    {
       RETVAL = ldap_sort_entries(ld,&chain,attr,StrCaseCmp);
    }
#line 2686 "LDAPapi.c"
	sv_setiv(ST(1), PTR2IV(chain));
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef MOZILLA_LDAP
#define XSubPPtmpAAAI 1


XS_EUPXS(XS_Net__LDAPapi_ldap_multisort_entries); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_multisort_entries)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, chain, attrs");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	chain = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	SV *	attrs = ST(2)
;
	int	RETVAL;
	dXSTARG;
#line 1479 "LDAPapi.xs"
    {
       char **attrs_char;
       SV ** current;
       int count,arraylen;
           if (SvTYPE(SvRV(attrs)) == SVt_PVAV)
           {
              if ((arraylen = av_len((AV *)SvRV(attrs))) < 0)
              {
                 New(1,attrs_char,2,char *);
                 attrs_char[0] = NULL;
              } else {
                 New(1,attrs_char,arraylen+2,char *);
                 for (count=0;count <= arraylen; count++)
                 {
                    current = av_fetch((AV *)SvRV(attrs),count,0);
                    attrs_char[count] = SvPV(*current,PL_na);
                 }
                 attrs_char[arraylen+1] = NULL;
              }
           } else {
              croak("Net::LDAPapi::ldap_multisort_entries needs ARRAY reference as argument 3.");
              XSRETURN(1);
           }
       RETVAL = ldap_multisort_entries(ld,&chain,attrs_char,StrCaseCmp);
    }
#line 2739 "LDAPapi.c"
	sv_setiv(ST(1), PTR2IV(chain));
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef OPENLDAP
#define XSubPPtmpAAAJ 1


XS_EUPXS(XS_Net__LDAPapi_ldap_start_tls); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_start_tls)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, serverctrls, clientctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(1)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(2)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;
#line 1519 "LDAPapi.xs"
    {
        RETVAL = ldap_start_tls(ld, serverctrls, clientctrls, &msgidp);
    }
#line 2772 "LDAPapi.c"
	sv_setiv(ST(3), (IV)msgidp);
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_start_tls_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_start_tls_s)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, serverctrls, clientctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(1)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(2)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_start_tls_s(ld, serverctrls, clientctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_sasl_interactive_bind_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_sasl_interactive_bind_s)
{
    dVAR; dXSARGS;
    if (items != 10)
       croak_xs_usage(cv,  "ld, who, passwd, serverctrls, clientctrls, mech, realm, authzid, props, flags");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	who = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAP_CHAR *	passwd = (LDAP_CHAR *)SvPV_nolen(ST(2))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	LDAP_CHAR *	mech = (LDAP_CHAR *)SvPV_nolen(ST(5))
;
	LDAP_CHAR *	realm = (LDAP_CHAR *)SvPV_nolen(ST(6))
;
	LDAP_CHAR *	authzid = (LDAP_CHAR *)SvPV_nolen(ST(7))
;
	LDAP_CHAR *	props = (LDAP_CHAR *)SvPV_nolen(ST(8))
;
	unsigned	flags = (unsigned)SvUV(ST(9))
;
	int	RETVAL;
	dXSTARG;
#line 1546 "LDAPapi.xs"
    {
        bictx ctx = {who, passwd, realm, authzid};
        if (props)
            ldap_set_option(ld, LDAP_OPT_X_SASL_SECPROPS, props);
        RETVAL = ldap_sasl_interactive_bind_s( ld, NULL, mech, serverctrls, clientctrls,
            flags, ldap_b2_interact, &ctx );
    }
#line 2841 "LDAPapi.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_sasl_bind_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_sasl_bind_s)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, dn, passwd, serverctrls, clientctrls, servercredp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAP_CHAR *	dn = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	LDAP_CHAR *	passwd = (LDAP_CHAR *)SvPV_nolen(ST(2))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	struct berval **	servercredp;
	int	RETVAL;
	dXSTARG;
#line 1565 "LDAPapi.xs"
    {
        struct berval cred;

        if( passwd == NULL )
            cred.bv_val = "";
        else
            cred.bv_val = passwd;

        cred.bv_len = strlen(cred.bv_val);

	servercredp = 0;	/* mdw 20070918 */
        RETVAL = ldap_sasl_bind_s(ld, dn, LDAP_SASL_SIMPLE, &cred,
                                  serverctrls, clientctrls, servercredp);
    }
#line 2883 "LDAPapi.c"
	sv_setiv(ST(5), PTR2IV(servercredp));
	SvSETMAGIC(ST(5));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__LDAPapi_ldap_controls_array_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_controls_array_init)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "total");
    {
	int	total = (int)SvIV(ST(0))
;
	LDAPControl **	RETVAL;
	dXSTARG;
#line 1589 "LDAPapi.xs"
    {
        LDAPControl ** array;
        array = malloc(total * sizeof(LDAPControl *));
        RETVAL = array;
    }
#line 2910 "LDAPapi.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_controls_array_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_controls_array_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctrls");
    {
	LDAPControl **	ctrls = INT2PTR(LDAPControl **,SvIV(ST(0)))
;
#line 1601 "LDAPapi.xs"
    {
        //int i;
        //for( i = 0; ctrls[i] != NULL; i++ )
        //    free((LDAPControl *)ctrls[i]);

        free(ctrls);
    }
#line 2934 "LDAPapi.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LDAPapi_ldap_control_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_control_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "array, ctrl, location");
    {
	LDAPControl **	array = INT2PTR(LDAPControl **,SvIV(ST(0)))
;
	LDAPControl *	ctrl = INT2PTR(LDAPControl *,SvIV(ST(1)))
;
	int	location = (int)SvIV(ST(2))
;
#line 1616 "LDAPapi.xs"
    {
        array[location] = ctrl;
    }
#line 2957 "LDAPapi.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LDAPapi_ldap_create_control); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_create_control)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "oid, bv_val, bv_len, iscritical, ctrlp");
    {
	LDAP_CHAR *	oid = (LDAP_CHAR *)SvPV_nolen(ST(0))
;
	LDAP_CHAR *	bv_val = (LDAP_CHAR *)SvPV_nolen(ST(1))
;
	int	bv_len = (int)SvIV(ST(2))
;
	int	iscritical = (int)SvIV(ST(3))
;
	LDAPControl *	ctrlp;
	int	RETVAL;
	dXSTARG;
#line 1628 "LDAPapi.xs"
    {
        LDAPControl *ctrl = malloc(sizeof(LDAPControl));

        ctrl->ldctl_oid          = ber_strdup(oid);
        ctrl->ldctl_value.bv_val = ber_strdup(bv_val);
        ctrl->ldctl_value.bv_len = bv_len;
        ctrl->ldctl_iscritical   = iscritical;

        ctrlp = ctrl;

        RETVAL = 0;
    }
#line 2994 "LDAPapi.c"
	sv_setiv(ST(4), PTR2IV(ctrlp));
	SvSETMAGIC(ST(4));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__LDAPapi_ldap_control_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ldap_control_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctrl");
    {
	LDAPControl *	ctrl = INT2PTR(LDAPControl *,SvIV(ST(0)))
;

	ldap_control_free(ctrl);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__LDAPapi_ber_alloc_t); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__LDAPapi_ber_alloc_t)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "options");
    {
	int	options = (int)SvIV(ST(0))
;
	BerElement *	RETVAL;
	dXSTARG;

	RETVAL = ber_alloc_t(options);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Net__LDAPapi); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__LDAPapi)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        (void)newXSproto_portable("Net::LDAPapi::constant", XS_Net__LDAPapi_constant, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::constant_s", XS_Net__LDAPapi_constant_s, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_initialize", XS_Net__LDAPapi_ldap_initialize, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_create", XS_Net__LDAPapi_ldap_create, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_bind_s", XS_Net__LDAPapi_ldap_bind_s, file, "$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_set_option", XS_Net__LDAPapi_ldap_set_option, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_get_option", XS_Net__LDAPapi_ldap_get_option, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_unbind_ext_s", XS_Net__LDAPapi_ldap_unbind_ext_s, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_search_s", XS_Net__LDAPapi_ldap_search_s, file, "$$$$$$$");
#if XSubPPtmpAAAA
        (void)newXSproto_portable("Net::LDAPapi::ldap_version", XS_Net__LDAPapi_ldap_version, file, "$");
#endif
        (void)newXSproto_portable("Net::LDAPapi::ldap_abandon_ext", XS_Net__LDAPapi_ldap_abandon_ext, file, "$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_add_ext", XS_Net__LDAPapi_ldap_add_ext, file, "$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_add_ext_s", XS_Net__LDAPapi_ldap_add_ext_s, file, "$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_sasl_bind", XS_Net__LDAPapi_ldap_sasl_bind, file, "$$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_modify_ext", XS_Net__LDAPapi_ldap_modify_ext, file, "$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_modify_ext_s", XS_Net__LDAPapi_ldap_modify_ext_s, file, "$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_rename", XS_Net__LDAPapi_ldap_rename, file, "$$$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_rename_s", XS_Net__LDAPapi_ldap_rename_s, file, "$$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_compare_ext", XS_Net__LDAPapi_ldap_compare_ext, file, "$$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_compare_ext_s", XS_Net__LDAPapi_ldap_compare_ext_s, file, "$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_delete_ext", XS_Net__LDAPapi_ldap_delete_ext, file, "$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_delete_ext_s", XS_Net__LDAPapi_ldap_delete_ext_s, file, "$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_search_ext", XS_Net__LDAPapi_ldap_search_ext, file, "$$$$$$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_search_ext_s", XS_Net__LDAPapi_ldap_search_ext_s, file, "$$$$$$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_result", XS_Net__LDAPapi_ldap_result, file, "$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_msgfree", XS_Net__LDAPapi_ldap_msgfree, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ber_free", XS_Net__LDAPapi_ber_free, file, "$$");
#if XSubPPtmpAAAB
        (void)newXSproto_portable("Net::LDAPapi::ldap_msgid", XS_Net__LDAPapi_ldap_msgid, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_msgtype", XS_Net__LDAPapi_ldap_msgtype, file, "$");
#endif
#if XSubPPtmpAAAC
        (void)newXSproto_portable("Net::LDAPapi::ldap_msgid", XS_Net__LDAPapi_ldap_msgid, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_msgtype", XS_Net__LDAPapi_ldap_msgtype, file, "$");
#endif
#if XSubPPtmpAAAD
        (void)newXSproto_portable("Net::LDAPapi::ldap_get_lderrno", XS_Net__LDAPapi_ldap_get_lderrno, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_set_lderrno", XS_Net__LDAPapi_ldap_set_lderrno, file, "$$$$");
#endif
#if XSubPPtmpAAAE
        (void)newXSproto_portable("Net::LDAPapi::ldap_get_lderrno", XS_Net__LDAPapi_ldap_get_lderrno, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_set_lderrno", XS_Net__LDAPapi_ldap_set_lderrno, file, "$$$$");
#endif
        (void)newXSproto_portable("Net::LDAPapi::ldap_get_entry_controls", XS_Net__LDAPapi_ldap_get_entry_controls, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_parse_result", XS_Net__LDAPapi_ldap_parse_result, file, "$$$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_parse_intermediate", XS_Net__LDAPapi_ldap_parse_intermediate, file, "$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_control_oid", XS_Net__LDAPapi_ldap_control_oid, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_control_berval", XS_Net__LDAPapi_ldap_control_berval, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_control_critical", XS_Net__LDAPapi_ldap_control_critical, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_err2string", XS_Net__LDAPapi_ldap_err2string, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_count_references", XS_Net__LDAPapi_ldap_count_references, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_count_entries", XS_Net__LDAPapi_ldap_count_entries, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_first_entry", XS_Net__LDAPapi_ldap_first_entry, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_next_entry", XS_Net__LDAPapi_ldap_next_entry, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_first_message", XS_Net__LDAPapi_ldap_first_message, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_next_message", XS_Net__LDAPapi_ldap_next_message, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_get_dn", XS_Net__LDAPapi_ldap_get_dn, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_perror", XS_Net__LDAPapi_ldap_perror, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_dn2ufn", XS_Net__LDAPapi_ldap_dn2ufn, file, "$");
#if XSubPPtmpAAAF
        (void)newXSproto_portable("Net::LDAPapi::ldap_str2dn", XS_Net__LDAPapi_ldap_str2dn, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_str2rdn", XS_Net__LDAPapi_ldap_str2rdn, file, "$$$$");
#endif
        (void)newXSproto_portable("Net::LDAPapi::ldap_explode_dn", XS_Net__LDAPapi_ldap_explode_dn, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_explode_rdn", XS_Net__LDAPapi_ldap_explode_rdn, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_first_attribute", XS_Net__LDAPapi_ldap_first_attribute, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_next_attribute", XS_Net__LDAPapi_ldap_next_attribute, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_get_values_len", XS_Net__LDAPapi_ldap_get_values_len, file, "$$$");
#if XSubPPtmpAAAG
        (void)newXSproto_portable("Net::LDAPapi::ldapssl_client_init", XS_Net__LDAPapi_ldapssl_client_init, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldapssl_init", XS_Net__LDAPapi_ldapssl_init, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldapssl_install_routines", XS_Net__LDAPapi_ldapssl_install_routines, file, "$");
#endif
        (void)newXSproto_portable("Net::LDAPapi::ldap_set_rebind_proc", XS_Net__LDAPapi_ldap_set_rebind_proc, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_get_all_entries", XS_Net__LDAPapi_ldap_get_all_entries, file, "$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_is_ldap_url", XS_Net__LDAPapi_ldap_is_ldap_url, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_url_parse", XS_Net__LDAPapi_ldap_url_parse, file, "$");
#if XSubPPtmpAAAH
        (void)newXSproto_portable("Net::LDAPapi::ldap_url_search", XS_Net__LDAPapi_ldap_url_search, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_url_search_s", XS_Net__LDAPapi_ldap_url_search_s, file, "$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_url_search_st", XS_Net__LDAPapi_ldap_url_search_st, file, "$$$$$");
#endif
        (void)newXSproto_portable("Net::LDAPapi::ldap_sort_entries", XS_Net__LDAPapi_ldap_sort_entries, file, "$$$");
#if XSubPPtmpAAAI
        (void)newXSproto_portable("Net::LDAPapi::ldap_multisort_entries", XS_Net__LDAPapi_ldap_multisort_entries, file, "$$$");
#endif
#if XSubPPtmpAAAJ
        (void)newXSproto_portable("Net::LDAPapi::ldap_start_tls", XS_Net__LDAPapi_ldap_start_tls, file, "$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_start_tls_s", XS_Net__LDAPapi_ldap_start_tls_s, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_sasl_interactive_bind_s", XS_Net__LDAPapi_ldap_sasl_interactive_bind_s, file, "$$$$$$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_sasl_bind_s", XS_Net__LDAPapi_ldap_sasl_bind_s, file, "$$$$$$");
#endif
        (void)newXSproto_portable("Net::LDAPapi::ldap_controls_array_init", XS_Net__LDAPapi_ldap_controls_array_init, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_controls_array_free", XS_Net__LDAPapi_ldap_controls_array_free, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_control_set", XS_Net__LDAPapi_ldap_control_set, file, "$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_create_control", XS_Net__LDAPapi_ldap_create_control, file, "$$$$$");
        (void)newXSproto_portable("Net::LDAPapi::ldap_control_free", XS_Net__LDAPapi_ldap_control_free, file, "$");
        (void)newXSproto_portable("Net::LDAPapi::ber_alloc_t", XS_Net__LDAPapi_ber_alloc_t, file, "$");

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#if XSubPPtmpAAAE
#endif
#if XSubPPtmpAAAF
#endif
#if XSubPPtmpAAAG
#endif
#if XSubPPtmpAAAH
#endif
#if XSubPPtmpAAAI
#endif
#if XSubPPtmpAAAJ
#endif
#line 3180 "LDAPapi.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

